5 REM Author:H.Kaker,15-9-1988
10 REM **********************************
14 CLEAR
15 KEY OFF
20 OPEN"I",#1,"color.dat"
21 INPUT #1,X99
22 INPUT #1,Y99
23 INPUT #1,Z99
24 COLOR X99,Y99,Z99
25 CLS
30 SCREEN 0,0,0
40 REM **********************************
50 REM SET UP STORAGE ARRAY
60 REM **********************************
70 DIM E(500),BE%(500),TE%(500)
80 LOCATE 2,28:PRINT TAB(29)"MONTE CARLO SIMULATION"
89 PRINT TAB(35)"THIN-FILMS"
140 LOCATE 10,2:PRINT TAB(28)"EXPERIMENTAL CONDITIONS"
155 PRINT
160 PRINT TAB(28):INPUT"What element : ",NA$
170 FOR J=1 TO 30
180 READ NM$
190 READ Z
200 READ AA
210 READ RH:IF NM$=NA$ THEN GOTO 240
220 NEXT:PRINT TAB(28)"Data not stored"
230 GOTO 280
240 PRINT TAB(28)"Atomic number : ";Z
250 PRINT TAB(28)"Atomic weight : ";AA
260 PRINT TAB(28)"Density (g/cm^3) : ";RH
270 GOTO 310
280 PRINT TAB(28):INPUT"Density (g/cm^3) : ",RH
290 PRINT TAB(28):INPUT"Atomic number : ",Z
300 PRINT TAB(28):INPUT"Atomic weight : ",AA
310 PRINT TAB(28):INPUT"Accelerating voltage (keV) : ",EI
320 PRINT TAB(28):INPUT"Tilt (degrees) : ",TI
321 PRINT TAB(28):INPUT"Number of electrons : ",PP
322 PRINT TAB(28):INPUT"Thin film thickness (microns) : ",YY:YY=YY/2
323 PRINT TAB(28):INPUT"Scale factor : ",XX
324 PRINT
340 ZG=Z
350 REM BETHE ENERGY LOSS
360 DEF FN SP(EN)=78500!*ZG*(LOG(1.166*EN/JB))/(AA*EN)
370 JB=(9.76*ZG+(58.5/(ZG^.19)))*.001
380 AH=.263*(ZG^.4)
390 B=.072*ZG/AH
400 B=B*((EI/15)^.95)
410 FOR M=1 TO 21 : EN=(M-1)*EI/20:IF EN >=(6.34*JB) THEN F=1/FN SP(EN) :GOTO 430
420 F=(SQR(EN*JB))*AA/(62400!*ZG)
430 L=2:IF M/2=INT (M/2) THEN L=4
440 IF M=1 OR M=21 THEN L=1
450 FS=FS+L*F:NEXT M:R=FS*EI/60:REM R IS MASSTHICKNESS/KV
460 SS=R/50:E(1)=EI
470 FOR M=2 TO 51:IF E(M-1)<(6.34*JB) THEN 520
480 A1=SS*FN SP(E(M-1)):IF A1/2 > E(M-1) THEN 520
490 A2=SS*FN SP(E(M-1)-A1/2):IF A2/2>E(M-1) THEN 520
500 A3=SS*FN SP(E(M-1)-A2/2):IF A3>E(M-1) THEN 520
510 A4=SS*FN SP(E(M-1)-A3):E(M)=E(M-1)-(A1+2*A2+2*A3+A4)/6:GOTO 530
520 EM=E(M-1)^1.5-93500!*ZG*SS/(AA*SQR(JB)):E(M)=0:IF EM>1E-09 THEN E(M)=EM^.6667
530 NEXT M:E(51)=0:FOR M=2 TO 50:E(M)=(E(M)+E(M+1))/2:NEXT M
540 SL=SS*500000!/RH:PRINT TAB(28)"CALCULATING RANGE"
545 PRINT TAB(28)"Range (microns) : ";
546 PRINT USING"###.###";SL
547 FOR N=1 TO 500:FF=LOG(999):NEXT N
550 ZS=INT(320/SL)
551 ZS=ZS*XX
560 CLS:SCREEN 2,0,0
570 ST=SL/50
575 LOCATE 3,1:PRINT TAB(4)"1 Microns"
576 LOCATE 3,62:PRINT"Thin film: ";NA$
580 LINE (25,10)-((25+ZS),10)
590 NE=0:BS=0:TE=0
600 LINE (25,50)-(595,50):LINE ((320+20*TAN(TI/57.4)),30)-(320,50)
605 LINE (25,50)-(595,50+YY*ZS),,B
610 FOR N=1 TO 99:Q=LOG(99):NEXT N
615 LINE (1,1)-(619,199),,B
620 LOCATE 21,4:PRINT TAB(39)"Total:"
630 LOCATE 22,4:PRINT TAB(42)"BE:"
635 LOCATE 23,4:PRINT TAB(42)"TE:"
660 REM ************************************************
670 REM SET UP INITIAL COORDINATES
680 REM **************************
685 IF NE>=PP GOTO 1190
690 X=0:Y=0:Z=0:CX=0:CY=SIN(TI/57.4):CZ=COS(TI/57.4):K=1:PSET (320,50)
700 FOR K=1 TO 50
710 REM **************************
720 REM SCATTERING ANGLES
730 REM **************************
740 NU=(RND(1)^.5):NU=((1/NU)-1):AN=NU*B/E(K)
750 SP=(AN+AN)/((AN*AN)+1)
760 CP=(1-(AN*AN))/((AN*AN)+1)
770 REM ***********************
780 REM AZIMUTHAL SCATTERING ANGLE
790 REM **************************
800 R2=RND (3):GA=6.28*R2
810 IF CZ=0 THEN CZ=.0001
820 M=-(CX/CZ)
830 N=1/SQR(1+(M*M))
840 REM ****************************
850 REM CALCULATE NEW COORDINATES
860 REM ****************************
870 CM=COS(M):CN=COS(N):SG=SIN(GA):CG=COS(GA)
880 CA=(CX*CP)+(CM*SP*CG)+(CY*CN*SP*SG)
890 CB=(CY*CP)+(SP*SG*(CZ*CM-CX*CN))
900 CC=(CZ*CP)+(SP*CN*CG)-(SP*CY*CM*SG)
910 XN=X+ST*CA:YN=Y+ST*CB:ZN=Z+ST*CC
920 REM ****************************
930 REM PLOT NEW POINT
940 REM ****************************
950 Y2=320-(YN*ZS):Z2=50+(ZN*ZS*.5)
960 IF Y2<25 THEN Y2=25:GOTO 980
970 IF Y2>595 THEN Y2=595
980 IF Z2<50 THEN Z2=50:LINE -(Y2,Z2):GOTO 1100
990 IF Z2>50+YY*ZS THEN Z2=50+YY*ZS   :LINE -(Y2,Z2):GOTO 1161
1000 LINE -(Y2,Z2)
1010 REM *******************************
1020 REM CALCULATE DIRECTION COSINES
1030 REM *******************************
1040 CX=CA:CY=CB:CZ=CC
1050 X=XN:Y=YN:Z=ZN
1070 LOCATE 20,8:PRINT TAB(29)"Energy (keV) is:";:PRINT USING"###.###";E(K)
1080 NEXT K
1090 NE=NE+1:LOCATE 21,4:PRINT TAB(39)"Total:";NE:GOTO 685
1100 REM ***************************
1110 REM BACKSCATTERED ELECTRON
1120 REM *****************************************
1130 BS=BS+1:NE=NE+1
1140 J=INT(E(K)+.5):BE%(J)=BE%(J)+1
1150 LOCATE 21,4:PRINT TAB(39)"Total:";NE
1155 LOCATE 22,4:PRINT TAB(42)"BE:";BS
1160 LOCATE 23,4:PRINT TAB(42)"TE:":GOTO 685
1161 REM TRANSMISSION ELECTRONS **************************
1162 TE=TE+1:NE=NE+1
1163 J=INT(E(K)+.5):TE%(J)=TE%(J)+1
1164 LOCATE 21,4:PRINT TAB(39)"Total:";NE
1165 LOCATE 22,4:PRINT TAB(42)"BE:"
1166 LOCATE 23,4:PRINT TAB(42)"TE:";TE
1170 GOTO 685
1190 A$=INKEY$:IF A$="" GOTO 1190
1191 CLS:SCREEN 2:SCREEN 0
1192 COLOR X99,Y99,Z99
1193 CLS
1200 REM DATA PRINT ON SCREEN
1220 LOCATE 6,25:PRINT"BS coefficient : ";
1230 PRINT USING"#.###";BS/NE
1235 LOCATE 8,14:PRINT"Energy distribution of backscattered electrons"
1240 LOCATE 10,24:PRINT"Energy (keV)";TAB(46)"No.":PRINT:SUM=0:AV=0:FOR J=0 TO EI
1241 PRINT TAB(27)"";J;TAB(45)"";BE%(J):IF J=20 THEN GOSUB 1900
1242 IF J=40 THEN GOSUB 1900
1243 IF J=60 THEN GOSUB 1900
1244 IF J=80 THEN GOSUB 1900
1245 IF J=100 THEN GOSUB 1900
1246 IF J=120 THEN GOSUB 1900
1247 IF J=140 THEN GOSUB 1900
1252 SUM=SUM+BE%(J):AV=AV+J*BE%(J)
1253 NEXT J:IF SUM=0 GOTO 1255 ELSE 1254
1254 PRINT:PRINT TAB(25)"Averaged energy (keV) : ";:PRINT USING"###.###";AV/SUM
1255 PRINT:PRINT:PRINT TAB(25)"TS coefficient : ";
1256 PRINT USING"#.###";TE/NE
1257 PRINT:PRINT TAB(14)"Energy distribution of transmission electrons":PRINT
1258 PRINT TAB(25)"Energy (keV)";TAB(46)"No.":PRINT:SUM=0:AV=0:FOR J=0 TO EI
1259 PRINT TAB(27)"";J;TAB(45)"";TE%(J)
1260 IF J=20 THEN GOSUB 1900
1262 IF J=40 THEN GOSUB 1900
1264 IF J=60 THEN GOSUB 1900
1266 IF J=80 THEN GOSUB 1900
1268 IF J=100 THEN GOSUB 1900
1270 IF J=120 THEN GOSUB 1900
1272 IF J=140 THEN GOSUB 1900
1280 SUM=SUM+TE%(J):AV=AV+J*TE%(J):NEXT J
1284 IF SUM=0 GOTO 1390 ELSE 1288
1288 PRINT:PRINT:PRINT TAB(25)"Averaged energy (keV) : ";:PRINT USING"###.###";AV/SUM
1390 PRINT:PRINT
1400 PRINT TAB(28):INPUT"Hard copy (y/n) : ",SX$
1401 IF SX$="Y" OR SX$="y" GOTO 1404
1403 IF SX$="N" OR SX$="n" GOTO 1950
1404 LPRINT:LPRINT
1405 LPRINT CHR$(27)+"G";
1410 LPRINT TAB(21)"MONTE CARLO SIMULATION - THIN FILMS"
1415 LPRINT CHR$(27)+"H";
1420 LPRINT:LPRINT
1430 LPRINT TAB(25)"Element :";NA$
1440 LPRINT TAB(25)"Accelerating voltage (keV) :";EI
1450 LPRINT TAB(25)"Tilt (degrees) :";TI
1460 LPRINT TAB(25)"Number of electrons :";PP
1470 LPRINT TAB(25)"Electron range (microns) :";
1475 LPRINT USING"##.###";SL
1480 LPRINT TAB(25)"BS coefficient :";
1485 LPRINT USING"#.###";BS/NE
1486 LPRINT TAB(25)"TS coefficient :";
1488 LPRINT USING"#.###";TE/NE
1490 LPRINT
1500 LPRINT TAB(15)"Energy distribution of backscattered electrons"
1510 LPRINT
1520 LPRINT TAB(24)"Energy (keV)";TAB(46)"No."
1530 LPRINT
1535 SUM=0:AV=O:FOR J=1 TO EI
1540 LPRINT TAB(27)"";J;TAB(45)"";BE%(J)
1545 SUM=SUM+BE%(J):AV=AV+J*BE%(J):NEXT J
1546 IF SUM=0 GOTO 1570
1550 LPRINT
1560 LPRINT TAB(25)"Averaged energy (keV) :";
1565 LPRINT USING"###.###";AV/SUM
1570 LPRINT:LPRINT
1580 LPRINT TAB(15)"Energy distribution of transmission electrons"
1590 LPRINT
1600 LPRINT TAB(24)"Energy (keV)";TAB(46)"No."
1610 LPRINT
1615 SUM=0:AV=0
1620 FOR J=0 TO EI
1630 LPRINT TAB(27)"";J;TAB(45)"";TE%(J)
1640 SUM=SUM+TE%(J):AV=AV+J*TE%(J):NEXT J
1650 IF SUM=0 GOTO 2000 ELSE 1660
1660 LPRINT
1670 LPRINT TAB(25)"Averaged energy (keV) :";
1680 LPRINT USING"###.###";AV/SUM
1690 LPRINT:LPRINT:LPRINT
1700 GOTO 1950
1800 DATA Be,4,9.01,1.848,B,5,10.81,2.5,C,6,12.01,2.34,Na,11,22.99,0.97,Mg,12,24.31,1.74
1810 DATA Al,13,26.98,2.7,Si,14,28.09,2.34,P,15,30.97,2.2,Ca,20,40,1.54,Ti,22,47.9,4.5,V,23,50.94,6.1,Cr,24,52,7.1
1820 DATA Mn,25,54.94,7.4,Fe,26,55.85,7.87,Co,27,58.93,8.9,Ni,28,58.71,8.9,Cu,29,63.55,8.96,Zn,30,65.37,7.14
1830 DATA Ga,31,69.72,5.91,Ge,32,72.59,5.32,Nb,41,92.91,8.6,Mo,42,95.94,10.2,Pd,46,106.4,12,Ag,47,107.9,10.5
1840 DATA Cd,48,112.4,8.64,Sn,50,118.7,7.3,W,74,183.9,19.3,Pt,78,195.1,21.45,Au,79,197.0,19.3,Pb,82,207.2,11.34
1900 REM podprogram za ustavitev izpisa na ekranu
1910 A$=INKEY$:IF A$="" GOTO 1910
1920 RETURN
1950 CLS
1955 LOCATE 12,27:INPUT"Another simulation (y/n): ",DDD$
1956 IF DDD$="y" OR DDD$="Y" GOTO 14 ELSE 2000
2000 CLS:CLOSE
2010 OPEN"i",#5,"menu.dat"
2020 INPUT #5,XY999
2030 IF XY999=1 GOTO 2050
2040 IF XY999=0 GOTO 2060
2050 CLS:CLOSE:RUN"ms.exe":END
2060 CLS:CLOSE:SYSTEM:END
