50 ' Program thin film analysis-direct elemental ratio method
55 ' Reference:J.C.Russ,The direct elemental ratio model for quantitative
56 ' analysis of thin sections
60 ' Author:Henrik Kaker,3-nov-88
65 CLEAR:KEY OFF
70 OPEN"i",#1,"color.dat"
75 INPUT #1,X999
76 INPUT #1,Y999
77 INPUT #1,Z999
80 COLOR X999,Y999,Z999
100 CLS
104 DIM AA(15),L$(15),L(15),Z$(15),Z(15),A5(15),A6(15),OO(15),EC(15),U(15)
105 DIM Q(15),A(15),I(15),K(15),M1(15),M2(15),M3(15),T(15),P(15),CC(15)
106 DIM R(15),S(15),XX(15),C(15),G(15),Y(15),M100(15),M200(15),M300(15)
110 T$="THIN SECTIONS-DIRECT ELEMENTAL RATIO MODEL"
120 LOCATE 5,(80-LEN(T$))/2
130 PRINT T$
135 OPEN "I",#2,"SPT.DAT"
136 INPUT #2,V1:INPUT #2,V2:INPUT #2,V3:INPUT #2,V4
137 V1=V1*.0001:V2=V2*.0001:V3=V3*.0001
140 LOCATE 9,23
150 INPUT"Accelerating voltage (keV): ",V
155 V=V*1000
158 IF V=>30000 THEN V=(1+9.875E-07*V)*V
160 LOCATE 11,25
170 INPUT"Take-off angle (degrees): ",T
180 T=.0174533*T
190 LOCATE 13,31
200 INPUT"Number of elements: ",AA
210 LOCATE 15,25
220 INPUT"Elements or oxides (e/o): ",UU$
282 IF UU$="O" OR UU$="o" GOTO 283 ELSE 285
283 CLS:LOCATE 3,18
284 PRINT TAB(21)"Element";TAB(38)"Line";TAB(52)"Int";TAB(63)"Stehiom.ratio":GOTO 290
285 CLS:LOCATE 3,18
286 PRINT TAB(21)"Element";TAB(38)"Line";TAB(52)"Int"
290 FOR N1=1 TO AA
300 LOCATE (4+N1),24:INPUT"",Z$(N1)
301 IF Z$(N1)="C" OR Z$(N1)="c" THEN Z(N1)=6
302 IF Z$(N1)="N" OR Z$(N1)="n" THEN Z(N1)=7
303 IF Z$(N1)="O" OR Z$(N1)="o" THEN Z(N1)=8
304 IF Z$(N1)="F" OR Z$(N1)="f" THEN Z(N1)=9
305 IF Z$(N1)="Na" OR Z$(N1)="NA" OR Z$(N1)="na" THEN Z(N1)=11
306 IF Z$(N1)="Mg" OR Z$(N1)="MG" OR Z$(N1)="mg" THEN Z(N1)=12
307 IF Z$(N1)="Al" OR Z$(N1)="AL" OR Z$(N1)="al" THEN Z(N1)=13
308 IF Z$(N1)="Si" OR Z$(N1)="SI" OR Z$(N1)="si" THEN Z(N1)=14
309 IF Z$(N1)="S" OR Z$(N1)="s" THEN Z(N1)=16
310 IF Z$(N1)="Cl" OR Z$(N1)="CL" OR Z$(N1)="cl" THEN Z(N1)=17
311 IF Z$(N1)="K" OR Z$(N1)="k" THEN Z(N1)=19
312 IF Z$(N1)="Ca" OR Z$(N1)="CA" OR Z$(N1)="ca" THEN Z(N1)=20
313 IF Z$(N1)="Sc" OR Z$(N1)="SC" OR Z$(N1)="sc" THEN Z(N1)=21
314 IF Z$(N1)="Ti" OR Z$(N1)="TI" OR Z$(N1)="ti" THEN Z(N1)=22
315 IF Z$(N1)="V" OR Z$(N1)="v" THEN Z(N1)=23
316 IF Z$(N1)="Cr" OR Z$(N1)="CR" OR Z$(N1)="cr" THEN Z(N1)=24
317 IF Z$(N1)="Mn" OR Z$(N1)="MN" OR Z$(N1)="mn" THEN Z(N1)=25
318 IF Z$(N1)="Fe" OR Z$(N1)="FE" OR Z$(N1)="fe" THEN Z(N1)=26
319 IF Z$(N1)="Co" OR Z$(N1)="CO" OR Z$(N1)="co" THEN Z(N1)=27
320 IF Z$(N1)="Ni" OR Z$(N1)="NI" OR Z$(N1)="ni" THEN Z(N1)=28
321 IF Z$(N1)="Cu" OR Z$(N1)="CU" OR Z$(N1)="cu" THEN Z(N1)=29
322 IF Z$(N1)="Zn" OR Z$(N1)="ZN" OR Z$(N1)="zn" THEN Z(N1)=30
323 IF Z$(N1)="Ga" OR Z$(N1)="GA" OR Z$(N1)="ga" THEN Z(N1)=31
324 IF Z$(N1)="Ge" OR Z$(N1)="GE" OR Z$(N1)="ge" THEN Z(N1)=32
325 IF Z$(N1)="As" OR Z$(N1)="AS" OR Z$(N1)="as" THEN Z(N1)=33
326 IF Z$(N1)="Se" OR Z$(N1)="SE" OR Z$(N1)="se" THEN Z(N1)=34
327 IF Z$(N1)="Br" OR Z$(N1)="BR" OR Z$(N1)="br" THEN Z(N1)=35
328 IF Z$(N1)="Rb" OR Z$(N1)="RB" OR Z$(N1)="rb" THEN Z(N1)=37
329 IF Z$(N1)="Sr" OR Z$(N1)="SR" OR Z$(N1)="sr" THEN Z(N1)=38
330 IF Z$(N1)="Y" OR Z$(N1)="y" THEN Z(N1)=39
331 IF Z$(N1)="Zr" OR Z$(N1)="ZR" OR Z$(N1)="zr" THEN Z(N1)=40
332 IF Z$(N1)="Nb" OR Z$(N1)="NB" OR Z$(N1)="nb" THEN Z(N1)=41
333 IF Z$(N1)="Mo" OR Z$(N1)="MO" OR Z$(N1)="mo" THEN Z(N1)=42
334 IF Z$(N1)="Tc" OR Z$(N1)="TC" OR Z$(N1)="tc" THEN Z(N1)=43
335 IF Z$(N1)="Ru" OR Z$(N1)="RU" OR Z$(N1)="ru" THEN Z(N1)=44
336 IF Z$(N1)="Rh" OR Z$(N1)="RH" OR Z$(N1)="rh" THEN Z(N1)=45
337 IF Z$(N1)="Pd" OR Z$(N1)="PD" OR Z$(N1)="pd" THEN Z(N1)=46
338 IF Z$(N1)="Ag" OR Z$(N1)="AG" OR Z$(N1)="ag" THEN Z(N1)=47
339 IF Z$(N1)="Cd" OR Z$(N1)="CD" OR Z$(N1)="cd" THEN Z(N1)=48
340 IF Z$(N1)="In" OR Z$(N1)="IN" OR Z$(N1)="in" THEN Z(N1)=49
341 IF Z$(N1)="Sn" OR Z$(N1)="SN" OR Z$(N1)="sn" THEN Z(N1)=50
342 IF Z$(N1)="Sb" OR Z$(N1)="SB" OR Z$(N1)="sb" THEN Z(N1)=51
343 IF Z$(N1)="Te" OR Z$(N1)="TE" OR Z$(N1)="te" THEN Z(N1)=52
344 IF Z$(N1)="I" OR Z$(N1)="i" THEN Z(N1)=53
345 IF Z$(N1)="Cs" OR Z$(N1)="CS" OR Z$(N1)="cs" THEN Z(N1)=55
346 IF Z$(N1)="Ba" OR Z$(N1)="BA" OR Z$(N1)="ba" THEN Z(N1)=56
347 IF Z$(N1)="La" OR Z$(N1)="LA" OR Z$(N1)="la" THEN Z(N1)=57
348 IF Z$(N1)="Ce" OR Z$(N1)="CE" OR Z$(N1)="ce" THEN Z(N1)=58
349 IF Z$(N1)="Pr" OR Z$(N1)="PR" OR Z$(N1)="pr" THEN Z(N1)=59
350 IF Z$(N1)="Nd" OR Z$(N1)="ND" OR Z$(N1)="nd" THEN Z(N1)=60
351 IF Z$(N1)="Pm" OR Z$(N1)="PM" OR Z$(N1)="pm" THEN Z(N1)=61
352 IF Z$(N1)="Sm" OR Z$(N1)="SM" OR Z$(N1)="sm" THEN Z(N1)=62
353 IF Z$(N1)="Eu" OR Z$(N1)="EU" OR Z$(N1)="eu" THEN Z(N1)=63
354 IF Z$(N1)="Gd" OR Z$(N1)="GD" OR Z$(N1)="gd" THEN Z(N1)=64
355 IF Z$(N1)="Tb" OR Z$(N1)="TB" OR Z$(N1)="tb" THEN Z(N1)=65
356 IF Z$(N1)="Dy" OR Z$(N1)="DY" OR Z$(N1)="dy" THEN Z(N1)=66
357 IF Z$(N1)="Ho" OR Z$(N1)="HO" OR Z$(N1)="ho" THEN Z(N1)=67
358 IF Z$(N1)="Er" OR Z$(N1)="ER" OR Z$(N1)="er" THEN Z(N1)=68
359 IF Z$(N1)="Tm" OR Z$(N1)="TM" OR Z$(N1)="tm" THEN Z(N1)=69
360 IF Z$(N1)="Yb" OR Z$(N1)="YB" OR Z$(N1)="yb" THEN Z(N1)=70
361 IF Z$(N1)="Lu" OR Z$(N1)="LU" OR Z$(N1)="lu" THEN Z(N1)=71
362 IF Z$(N1)="Hf" OR Z$(N1)="HF" OR Z$(N1)="hf" THEN Z(N1)=72
363 IF Z$(N1)="Ta" OR Z$(N1)="TA" OR Z$(N1)="ta" THEN Z(N1)=73
364 IF Z$(N1)="W" OR Z$(N1)="w" THEN Z(N1)=74
365 IF Z$(N1)="Re" OR Z$(N1)="RE" OR Z$(N1)="re" THEN Z(N1)=75
366 IF Z$(N1)="Os" OR Z$(N1)="OS" OR Z$(N1)="os" THEN Z(N1)=76
367 IF Z$(N1)="Ir" OR Z$(N1)="IR" OR Z$(N1)="ir" THEN Z(N1)=77
368 IF Z$(N1)="Pt" OR Z$(N1)="PT" OR Z$(N1)="pt" THEN Z(N1)=78
369 IF Z$(N1)="Au" OR Z$(N1)="AU" OR Z$(N1)="au" THEN Z(N1)=79
370 IF Z$(N1)="Hg" OR Z$(N1)="HG" OR Z$(N1)="hg" THEN Z(N1)=80
371 IF Z$(N1)="Tl" OR Z$(N1)="TL" OR Z$(N1)="tl" THEN Z(N1)=81
372 IF Z$(N1)="Pb" OR Z$(N1)="PB" OR Z$(N1)="pb" THEN Z(N1)=82
373 IF Z$(N1)="Bi" OR Z$(N1)="BI" OR Z$(N1)="bi" THEN Z(N1)=83
374 IF Z$(N1)="U" OR Z$(N1)="u" THEN Z(N1)=92
375 IF Z$(N1)="P" OR Z$(N1)="p" THEN Z(N1)=15
380 LOCATE (4+N1),39:INPUT"",L$(N1)
390 L(N1)=0
400 IF L$(N1)="K" OR L$(N1)="k" THEN L(N1)=1
410 IF L$(N1)="L" OR L$(N1)="l" THEN L(N1)=2
415 IF L$(N1)="M" OR L$(N1)="m" THEN L(N1)=3
440 LOCATE (4+N1),52:INPUT"",A5(N1)
450 IF UU$="O" OR UU$="o" GOTO 460 ELSE 470
460 LOCATE (4+N1),68:INPUT"",A6(N1)
470 NEXT N1
480 'Parameters
490 FOR N1=1 TO AA
500 'Fluorescence yield
510 IF L(N1)=1 THEN OO(N1)= (-.03795+.03426*Z(N1)-1.163E-06*Z(N1)^3)^4/(1+(-.03795+.03426*Z(N1)-1.163E-06*Z(N1)^3)^4)
520 IF L(N1)=2 THEN OO(N1)=(-.11107+.01368*Z(N1)-2.177E-07*Z(N1)^3)^4/(1+(-.11107+.01368*Z(N1)-2.177E-07*Z(N1)^3)^4)
525 IF L(N1)=3 THEN OO(N1)=(-.00036+.00368*Z(N1)+2.01E-07*Z(N1)^3)^4/(1+(-.00036+.00368*Z(N1)+2.01E-07*Z(N1)^3)^4)
530 'Ionization cross-section
540 'Energy of absorption edge
550 IF L(N1)=1 THEN EC(N1)=-.1304-.002633*Z(N1)+.009718*Z(N1)^2+4.144E-05*Z(N1)^3
560 IF L(N1)=2 THEN EC(N1)=-.4506+.01566*Z(N1)+.0007599*Z(N1)^2+1.792E-05*Z(N1)^3
565 IF L(N1)=3 THEN EC(N1)=2.8537E-06*Z(N1)^3.11494
570 'Overvoltage ratio
575 EC(N1)=EC(N1)*1000
580 U(N1)=V/EC(N1)
590 IF L(N1)=1 THEN B=.35
600 IF L(N1)=2 THEN B=.25
605 IF L(N1)=3 THEN B=.25
610 CC(N1)=4/(1.65+2.35*EXP(1-U(N1)))
620 IF L(N1)=1 THEN ZZ=2
630 IF L(N1)=2 THEN ZZ=8
635 IF L(N1)=3 THEN ZZ=18
640 REM IONIZATION CROSS-SECTION
650 Q(N1)=(6.51E-14*ZZ*B/(EC(N1)^2*U(N1)))*LOG(CC(N1)*U(N1))
660 REM atomic weight
670 A(N1)=-1.42+1.97*Z(N1)+.0103*Z(N1)^2-.0000429*Z(N1)^3
680 'Si(Li) efficiency
690 'K-alfa line
700 IF L(N1)=1 THEN K(N1)= EXP(-5.49184+2.54555*LOG(Z(N1))-.128429*(LOG(Z(N1)))^2+.0120661*(LOG(Z(N1)))^3)
710 IF L(N1)=2 THEN K(N1)=EXP(-13.2015+5.92457*LOG(Z(N1))-.790156*(LOG(Z(N1)))^2+.0560193*(LOG(Z(N1)))^3)
720 IF L(N1)=3 THEN K(N1)=EXP(6.66542-11.2046*LOG(Z(N1))+3.58209*(LOG(Z(N1)))^2-.303821*(LOG(Z(N1)))^3)
730 'Spectrometer effeciency
740 IF K(N1)=<1.487 THEN M100=.3102*(12.3981/K(N1))^3.001
741 IF K(N1)>1.487 THEN M100=2.4604*.111*(12.3981/K(N1))^3.03
750 IF K(N1)=<1.487 THEN M200=1.759*(12.3981/K(N1))^2.706
760 IF K(N1)>1.487 AND K(N1)<=2.0147 THEN M200=9.130901*1.8389*(12.3981/K(N1))^2.94
770 IF K(N1)>2.0147 THEN M200=19.57*(12.3981/K(N1))^2.7345
780 IF K(N1)=<1.487 THEN M300=41.17*(12.3981/K(N1))^1.906
781 IF K(N1)>1.487 AND K(N1)<=2.2057 THEN M300=19.4943*.7588*(12.3981/K(N1))^2.393
782 IF K(N1)>2.2057 AND K(N1)<=2.2911 THEN M300=19.4943*2.2057*(12.3981/K(N1))^2.2
783 IF K(N1)>2.2911 AND K(N1)<=2.743 THEN M300=19.4943*2.2911*(12.3981/K(N1))^2.4
784 IF K(N1)>2.743 AND K(N1)<=3.1478 THEN M300=19.4943*2.743*(12.3981/K(N1))^2.4471
785 IF K(N1)>3.1478 AND K(N1)<=3.4249 THEN M300=19.4943*3.1478*(12.3981/K(N1))^2.4471
786 IF K(N1)>3.4249 AND K(N1)<=11.9187 THEN M300=19.4943*3.4249*(12.3981/K(N1))^2.575
787 IF K(N1)>11.9187 AND K(N1)<=13.7336 THEN M300=19.4943*11.9187*(12.3981/K(N1))^2.3554
788 IF K(N1)>13.7336 AND K(N1)<=14.3528 THEN M300=19.4943*13.4336*(12.3981/K(N1))^2.61439
789 IF K(N1)>14.3528 THEN M300=19.4943*14.3528*(12.3981/K(N1))^2.65
800 T(N1)=EXP(-M100*(V1/COS(T))*1.85-M200*(V3/COS(T))*2.329-M300*(V2/COS(T))*19.3)*(1-EXP(-M200*(V4/COS(T))*2.329))
840 'P-factor
850 P(N1)=Q(N1)*OO(N1)*T(N1)
860 NEXT N1
950 REM-Concentrations
955 XX=0
960 FOR N1=1 TO AA
970 R(N1)=A5(N1)/A5(1)
980 S(N1)=P(1)/P(N1)
990 XX(N1)=S(N1)*R(N1)
1000 XX=XX+XX(N1)
1010 NEXT N1
1020 C1=1/XX
1040 FOR N1=1 TO AA
1050 C(N1)=S(N1)*R(N1)*C1
1060 NEXT N1
1070 REM atomic percent
1075 FOR N1=1 TO AA
1080 A(N1)=-1.42+1.97*Z(N1)+.0103*Z(N1)^2-.0000429*Z(N1)^3
1090 G(N1)=(C(N1)*100)/A(N1)
1100 NEXT N1
1110 GG=0
1120 FOR N1=1 TO AA
1130 GG=GG+G(N1)
1140 NEXT N1
1150 'Atomic percent oxides
1160 YY=0
1170 FOR N1=1 TO AA
1175 A(N1)=-1.42+1.97*Z(N1)+.0103*Z(N1)^2-.0000429*Z(N1)^3
1180 Y(N1)=(C(N1)*100)*(A(N1)+A6(N1)*15.9994)/A(N1)
1190 YY=YY+Y(N1)
1200 NEXT N1
1210 'Screen
1220 IF UU$="E" OR UU$="e" GOTO 1230 ELSE 1330
1230 CLS
1240 LOCATE 3,1
1250 PRINT TAB(1)"Element";TAB(12)"Line";TAB(21)"Int";TAB(29)"P(1)/P(N)";TAB(42)"Weight percent";TAB(59)"Atomic percent"
1260 FOR N1=1 TO AA
1270 LOCATE (5+N1),4:PRINT"";Z$(N1);TAB(13)"";L$(N1);TAB(15)"";
1274 PRINT USING"######.###";A5(N1)
1280 LOCATE (5+N1),29:PRINT USING"##.###";S(N1)
1290 LOCATE (5+N1),44:PRINT USING"###.###";C(N1)*100
1300 LOCATE (5+N1),61:PRINT USING"###.###";(G(N1)*100)/GG
1310 NEXT N1
1320 GOTO 1420
1330 REM-Weight percent oxides
1340 CLS
1345 LOCATE 3,1
1350 PRINT TAB(1)"Element";TAB(12)"Line";TAB(21)"Int";TAB(29)"P(1)/P(N1)";TAB(42)"Weight percent";TAB(59)"Weight percent oxide"
1360 FOR N1=1 TO AA
1370 LOCATE (5+N1),4:PRINT"";Z$(N1);TAB(13)"";L$(N1);TAB(15)"";
1374 PRINT USING"######.###";A5(N1)
1380 LOCATE (5+N1),30:PRINT USING"##.###";S(N1)
1390 LOCATE (5+N1),44:PRINT USING"###.###";C(N1)*100
1400 LOCATE (5+N1),62:PRINT USING"###.###";(Y(N1)*100)/YY
1410 NEXT N1
1420 LOCATE 23,30:INPUT"Hard copy (y/n): ",HHH$
1422 IF HHH$="n" OR HHH$="N" GOTO 4000
1424 IF HHH$="y" OR HHH$="Y" GOTO 1430
1430 CLS:LOCATE 13,28
1480 INPUT"Please type sample name: ",SX$
1490 IF UU$="E" OR UU$="e" GOTO 1600
1500 IF UU$="O" OR UU$="o" GOTO 1900
1600 LPRINT:LPRINT:LPRINT:LPRINT
1610 LPRINT CHR$(27)+"G";
1620 LPRINT TAB(24)"PROGRAM THIN FILM ANALYSIS"
1630 LPRINT CHR$(27)+"H";
1640 LPRINT:LPRINT
1650 LPRINT TAB(30)"  Date: ";DATE$
1660 LPRINT TAB(30)"  Time: ";TIME$
1670 LPRINT TAB(30)"Sample: ";SX$
1680 LPRINT:LPRINT
1685 V=V/1000
1690 LPRINT TAB(16)"Accelerating voltage: ";
1691 LPRINT USING"###.###";V;
1692 LPRINT" keV"
1700 LPRINT TAB(16)"      Take-off angle: ";INT((57.32484*T*100+.5)/100);" degrees"
1710 LPRINT TAB(16)"  Number of elements: ";AA
1720 LPRINT:LPRINT
1730 LPRINT TAB(1)"Element";TAB(12)"Line";TAB(21)"Int";TAB(29)"P(1)/P(N)";TAB(42)"Weight percent";TAB(59)"Atomic percent"
1740 LPRINT
1750 FOR N1=1 TO AA
1760 LPRINT TAB(4)"";Z$(N1);TAB(13)"";L$(N1);TAB(15)"";
1770 LPRINT USING"######.###";A5(N1);
1780 LPRINT TAB(29);
1785 LPRINT USING"##.###";S(N1);
1790 LPRINT TAB(44);
1795 LPRINT USING"###.###";C(N1)*100;
1800 LPRINT TAB(61);
1805 LPRINT USING"###.###";(G(N1)*100)/GG
1810 NEXT N1
1820 GOTO 4000
1900 LPRINT:LPRINT:LPRINT
1910 LPRINT CHR$(27)+"G";
1920 LPRINT TAB(25)"PROGRAM THIN FILM ANALYSIS"
1930 LPRINT CHR$(27)+"H";
1940 LPRINT:LPRINT
1950 LPRINT TAB(30)"  Date: ";DATE$
1960 LPRINT TAB(30)"  Time: ";TIME$
1970 LPRINT TAB(30)"Sample: ";SX$
1980 LPRINT:LPRINT
1985 V=V/1000
1990 LPRINT TAB(16)"Accelerating voltage: ";
1991 LPRINT USING"###.###";V;
1994 LPRINT" keV"
2000 LPRINT TAB(16)"      Take-off angle: ";INT((57.32484*T*100+.5)/100);" degrees"
2010 LPRINT TAB(16)"  Number of elements: ";AA
2020 LPRINT:LPRINT
2030 LPRINT TAB(1)"Element";TAB(12)"Line";TAB(21)"Int";TAB(29)"P(1)/P(N)";TAB(42)"Weight percent";TAB(59)"Weight % oxide"
2040 LPRINT
2050 FOR N1=1 TO AA
2060 LPRINT TAB(4)"";Z$(N1);TAB(13)"";L$(N1);TAB(15)"";
2070 LPRINT USING"######.###";A5(N1);
2080 LPRINT TAB(29);
2085 LPRINT USING"##.###";S(N1);
2090 LPRINT TAB(44);
2095 LPRINT USING"###.###";C(N1)*100;
2100 LPRINT TAB(61);
2110 LPRINT USING"###.###";(Y(N1)*100)/YY
2130 NEXT N1
4000 CLS:LOCATE 13,27:INPUT"Another calculation (y/n): ",ZZZ$
4010 IF ZZZ$="y" OR ZZZ$="Y" GOTO 50
4020 IF ZZZ$="n" OR ZZZ$="N" GOTO 4999
4999 CLOSE:CLS
5000 OPEN"i",#5,"menu.dat"
5010 INPUT #5,XY999
5020 IF XY999=1 GOTO 5050
5030 IF XY999=0 GOTO 5060
5050 CLOSE:RUN"ms.exe":END
5060 CLOSE:SYSTEM:END
